#ifndef PAGE_H
#define PAGE_H
#include "type.h"

#define PAGE_SIZE 4096
#define PAGE_INIT_OK     0
#define PAGE_INIT_ERROR -1

// bitmap操作的宏定义
#define BITMAP_SHIFT 6  // 64位
#define BITMAP_MASK  63
#define BITMAP_WORD(idx) ((idx) >> BITMAP_SHIFT)
#define BITMAP_BIT(idx)  ((idx) & BITMAP_MASK)

int init_physical_memory(void* start, uint64_t size);
void* alloc_page(void);
void free_page(void* page);
void set_page_used(void* page);
int is_page_used(void* page);

#endif