#define MAP(x, f) f(x)
#define concat_temp(a, b) a ## b
#define concat(a, b) concat_temp(a, b)
#define REGS(f) \
    f(1) f(3) f(4) f(5) f(6) f(7) f(8) \
    f(9) f(10) f(11) f(12) f(13) f(14) f(15) f(16) \
    f(17) f(18) f(19) f(20) f(21) f(22) f(23) f(24) \
    f(25) f(26) f(27) f(28) f(29) f(30) f(31)

#define SAVE(n) sd concat(x, n), ((n-1)*8)(sp);
#define RESTORE(n) ld concat(x, n), ((n-1)*8)(sp);

.section .text
.global switch_context
# void switch_context(Context** old_ctx, Context* new_ctx)
# a0: old_ctx
# a1: new_ctx
switch_context:
    addi sp, sp, -280

    MAP(SAVE, REGS)
    // 

    csrr t0, sepc
    sd t0, 31*8(sp)
    csrr t0, sstatus
    sd t0, 32*8(sp)
    csrr t0, satp
    sd t0, 33*8(sp)
    csrr t0, scause
    sd t0, 34*8(sp)

    sd sp, (a0)

    mv sp, a1

    ld t0, 31*8(sp)
    csrw sepc, t0
    ld t0, 32*8(sp)
    csrw sstatus, t0
    ld t0, 33*8(sp)
    csrw satp, t0
    ld t0, 34*8(sp)
    csrw scause, t0

    MAP(RESTORE, REGS)

    sfence.vma zero, zero   # flush TLB
    addi sp, sp, 280
    ret
