#ifndef TEST_H
#define TEST_H

#include <assert.h>
#include <stdio.h>

#define STRINGIFY(x) #x
#define TOSTRING(x) STRINGIFY(x)
#define Assert(condition) do { \
    if (!(condition)) { \
        printf("\033[0;31mTest Failed: " TOSTRING(__FILE__) " " TOSTRING(__LINE__) " \033[0m\n"); \
        assert(0); \
    } \
} while(0)

#define PASS(name) printf("\033[0;32mTest Passed: " #name "\033[0m\n");
#define TEST(name) do { \
    extern void test_##name(); \
    test_##name(); \
    PASS(name); \
} while(0)

void test();

#endif