#include "test.h"
#include "string.h"

void test_string_memset(){
    char buf[20] = "Hello, world";
    memset(buf, 0, 12);
    for (int i = 0; i < 12; i++)
    {
        Assert(buf[i] == 0);
    }
}
void test_string_memcpy(){
    char buf[20] = "Hello, world";
    char buf2[20];
    memcpy(buf2, buf, 12);
    Assert(strcmp(buf, buf2) == 0);
}
void test_string_memmove() {
    char src[50] = "Hello, world!";
    char dest[50];

    memmove(dest, src, strlen(src) + 1);
    Assert(strcmp(dest, "Hello, world!") == 0);

    char overlap_src1[50] = "1234567890";
    memmove(overlap_src1 + 4, overlap_src1, 6);
    Assert(strcmp(overlap_src1, "1234123456") == 0);

    char overlap_src2[50] = "1234567890";
    memmove(overlap_src2, overlap_src2 + 4, 6);
    Assert(strcmp(overlap_src2, "5678907890") == 0);

    char zero_src[50] = "Hello, world!";
    memmove(zero_src, zero_src + 5, 0);
    Assert(strcmp(zero_src, "Hello, world!") == 0);

    char same_src[50] = "Hello, world!";
    memmove(same_src, same_src, strlen(same_src) + 1);
    Assert(strcmp(same_src, "Hello, world!") == 0);
}
void test_string_strcmp(){
    char buf[20] = "Hello, world";
    Assert(strcmp(buf, "Hello, world") == 0);
    char buf2[4] = "bcd";
    Assert(strcmp(buf2, "bcd") == 0);
    Assert(strcmp(buf2, "bc") > 0);
    Assert(strcmp(buf2, "bcde") < 0);
    Assert(strcmp(buf2, "bce") < 0);
    Assert(strcmp(buf2, "ccd") < 0);
    Assert(strcmp(buf2, "acd") > 0);
}
void test_string_strncmp(){
    char buf[5] = "abcd";
    Assert(strncmp(buf, "abcd", 4) == 0);
    Assert(strncmp(buf, "abc", 3) == 0);
    Assert(strncmp(buf, "abcde", 5) < 0);
    Assert(strncmp(buf, "abce", 4) < 0);
    Assert(strncmp(buf, "abcc", 4) > 0);
    Assert(strncmp(buf, "abc", 4) > 0);
    Assert(strncmp(buf, "ab", 2) == 0);
}
void test_string_strlen(){
    char buf3[20] = "Hello, world";
    Assert(strlen(buf3) == 12);
    char buf4[5] = "\0\0";
    Assert(strlen(buf4) == 0);
}
void test_string_strcpy(){
    char buf5[20] = "Hello, world";
    char buf6[13];
    strcpy(buf6, buf5);
    Assert(strcmp(buf5, buf6) == 0);
}
void test_string_strcat(){
    char buf7[20] = "Hello, ";
    char buf8[7] = "world";
    strcat(buf7, buf8);
    Assert(strcmp(buf7, "Hello, world") == 0);
}

void test_string(){
    test_string_memset();
    test_string_memcpy();
    test_string_memmove();
    test_string_strcmp();
    test_string_strncmp();
    test_string_strlen();
    test_string_strcpy();
    test_string_strcat();
}